
/**
 * Module dependencies.
 */

var express = require('express')
  , routes = require('./routes')
  , user = require('./routes/user')
  , http = require('http')
  , path = require('path');

var app = express();

// all environments
app.set('port', process.env.PORT || 3000);
app.set('views', __dirname + '/views');
app.set('view engine', 'jade');
app.use(express.favicon());
app.use(express.logger('dev'));
app.use(express.bodyParser());
app.use(express.methodOverride());
app.use(app.router);
app.use(express.static(path.join(__dirname, 'public')));

// development only
if ('development' == app.get('env')) {
  app.use(express.errorHandler());
}
/////////////////////////////////////////////////////////////////
var MongoClient = require('mongodb').MongoClient;
var url = 'mongodb://localhost:27017/arduino';
var dbConn;
MongoClient.connect(url, function(err, db) {
	if (err) console.log(err) 
	else {
		console.log("Connected correctly to server");
		dbConn = db;
	}
});
/////////////////////////////////////////////////////////////////
//app.get('/', routes.index);
var request = require('request');
app.get('/buzzer',function(req,res) {
	request('http://192.168.0.67', function (error, response, body) {
	  if (!error && response.statusCode == 200) {
	    console.log(body);
	    var buzzer = dbConn.collection('buzzer');
	    var obj = JSON.parse(body);
	    obj.created_at = new Date();
	    buzzer.save(obj, function(err,result){
	    	if (err) console.log(err);
	    	else console.log(JSON.stringify(result));
	    });
	    res.send(body);
	  }
	});
});
app.get('/', function(req,res){//온도습도 정보 조회 API
	var dht11 = dbConn.collection('dht11');
	dht11.find({}).toArray(function(err, docs) {
		if (err) res.send(JSON.stringify({err:err}));
		else res.send(JSON.stringify(docs));
	});
});
app.get('/cds', function(req,res){//조도센서 정보 조회 API
	var cds = dbConn.collection('cds');
	cds.find({}).toArray(function(err, docs){
		if (err) res.send(JSON.stringify({err:err}));
		else res.send(JSON.stringify(docs));
	});
});
////////////////////////////////////////////////////////
var mqtt = require('mqtt')
var client  = mqtt.connect('mqtt://192.168.0.62')
client.on('connect', function () {
  client.subscribe('cds');
  client.subscribe('dht11');
  //client.publish('arduino', 'Hello mqtt');
});
client.on('message', function (topic, message) {
  console.log(message.toString());
  var data = JSON.parse(message.toString());
  data.created_at = new Date();
  if (topic == 'cds') {
	  var cds = dbConn.collection('cds');
	  cds.save(data, function(err, result) {
		 if (err) console.log(err);
		 else console.log(JSON.stringify(result));
	  });
  } else {
	  var dht11 = dbConn.collection('dht11');
	  dht11.save(data, function(err, result) {
		 if (err) console.log(err);
		 else console.log(JSON.stringify(result));
	  });
  }
});



app.get('/users', user.list);

http.createServer(app).listen(app.get('port'), function(){
  console.log('Express server listening on port ' + app.get('port'));
});
